#!/usr/bin/perl

# format_Excel-to-UPIC.pl
# Linda Ballard, 23 October 2009
# Input:  tab-delimited genemapper text file
#          Column 1 has names of markers
# Output: UPIC input-ready text file

my @markers = ();
$maxlines = 0;
my %starthash = (); #hash with ID/start pairs
my %endhash = (); #hash with ID/end pairs

#######################################################################
# get position information
print "col1-seq.ID, col2-size, col4&up-line\n";
print "seq.ID is in first row of data group\n";
print "Tab-delimited GeneMapper.txt file:> ";
chomp ($file = <STDIN>);

print "Headers are in row number:> ";
chomp ($startline = <STDIN>);

open(KEYIN, "$file") or die "Couldn't open $file: $!\n"; 

$file =~ s/\.\w+$//g;
$out = $file."\.upic-ready-input.txt";
open (OUT, ">$out") or die "Couldn't create $out: $!\n";
printf OUT "$file\tID\tMarker\tPeak\n";

while (<KEYIN>){
	chomp; 
	#for ($i=0; $i < $startline; $i++) { readline(KEYIN); }
	if ($. == $startline) { #get header line, with marker names
		@markers = split;
		$maxcolumns = @markers;
		$maxlines = $maxcolumns - 2;
		for ($i = 0; $i <= $#markers; $i++) {
			print "$i $markers[$i]\n";
		}
		print "\n$maxlines markers found\n";
			
	} else {
		@row =split (/\t/,$_);
		if($row[0]) {	$ID = $row[0]; }
		$peak = $row[1];
		for $z (2 .. $maxlines+1) { 
			if( $row[$z]) {
				printf OUT "$file\t$ID\t$markers[$z]\t$peak\n";
			}
		}
		
	}			
}
close (KEYIN); close (OUT);

exit;       